#!/usr/bin/perl
# Script instalacion de la RA de pkIRIS
#
# To start it type :
#       perl ra-install.pl
#
# This script is released under the GNU General Public License, version 2

# Inicializamos la variable de error a cero
my $error = 0;

print "
--------------------------------------------------------------------------------
SCRIPT DE INSTALACIÓN DE pkIRIS-RA
--------------------------------------------------------------------------------\n";

print "Pulse INTRO para comenzar la instalación\n"; 
my $begin=<STDIN>;

print "\nParseando el fichero XML con la configuración de la RA ..... ";
# Abrimos el fichero de configuracion XML y lo pasamos a un array
open (XMLFILE,"ra-config.xml");
my @xmlFile=<XMLFILE>;
close (XMLFILE);

# Pasamos el array a una cadena
my $cadena;
foreach $linea (@xmlFile)
{
   $cadena = $cadena . $linea;
} 

############################################################
# Parseamos la cadena con el contenido del fichero XML
############################################################
if ($cadena =~ /<pki type=(.*) version=.*>(.*?)<\/pki>/ms ) {
   my $XML;
   $XML{'pki'} = $1;
   if ($cadena =~ /<RA>(.*?)<\/RA>/ms ) {
      $XML{'RA'} = $1;

      # Parseamos las variables del sistema
      if ($XML{'RA'} =~ /<system>(.*?)<\/system>/ms ) {
         $XML{'system'} = $1;
         if ($XML{'system'} =~ /<apacheUser>(.*?)<\/apacheUser>/ms ) {
            $XML{'apacheUser'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'system'} =~ /<apacheGroup>(.*?)<\/apacheGroup>/ms ) {
            $XML{'apacheGroup'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'system'} =~ /<ldapUser>(.*?)<\/ldapUser>/ms ) {
            $XML{'ldapUser'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'system'} =~ /<ldapGroup>(.*?)<\/ldapGroup>/ms ) {
            $XML{'ldapGroup'} = $1;
         }
         else {
            $error = 1;
         }

      }
      else {
         $error = 1;
      }

      # Parseamos las variables de configuracion del ldap
      if ($XML{'RA'} =~ /<ldap>(.*?)<\/ldap>/ms ) {
         $XML{'ldap'} = $1;   
         if ($XML{'ldap'} =~ /<server>(.*?)<\/server>/ms ) {
            $XML{'server'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<port>(.*?)<\/port>/ms ) {
            $XML{'port'} = $1;
         } 
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<admin>(.*?)<\/admin>/ms ) {
            $XML{'admin'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<pwd>(.*?)<\/pwd>/ms ) {
            $XML{'pwd'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<base>(.*?)<\/base>/ms ) {
            $XML{'base'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<baseCrt>(.*?)<\/baseCrt>/ms ) {
            $XML{'baseCrt'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<rdnAttr>(.*?)<\/rdnAttr>/ms ) {
            $XML{'rdnAttr'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<adminCaMail>(.*?)<\/adminCaMail>/ms ) {
            $XML{'adminCaMail'} = $1;
         }
         else {
            $error = 1;
         }
         if ($XML{'ldap'} =~ /<adminRaMail>(.*?)<\/adminRaMail>/ms ) {
            $XML{'adminRaMail'} = $1;
         }
         else {
            $error = 1;
         }
      }
      # Ahora parseamos el resto de variables
      if ($XML{'RA'} =~ /<web>(.*?)<\/web>/ms ) {
         $XML{'web'} = $1;
         
         if ($XML{'web'} =~ /<directories>(.*?)<\/directories>/ms ) {
            $XML{'directories'} = $1;
        
            if ($XML{'directories'} =~ /<rootWeb>(.*?)<\/rootWeb>/ms ) {
               $XML{'rootWeb'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'directories'} =~ /<conf>(.*?)<\/conf>/ms ) {
               $XML{'conf'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'directories'} =~ /<data>(.*?)<\/data>/ms ) {
               $XML{'data'} = $1;
            }
            else {
               $error = 1;
            }            
            if ($XML{'directories'} =~ /<log>(.*?)<\/log>/ms ) {
               $XML{'log'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'directories'} =~ /<ldapDir>(.*?)<\/ldapDir>/ms ) {
               $XML{'ldapDir'} = $1;
            }
            else {
               $error = 1;
            }
         }

         if ($XML{'web'} =~ /<url>(.*?)<\/url>/ms ) {
            $XML{'url'} = $1;
         
            if ($XML{'url'} =~ /<root>(.*?)<\/root>/ms ) {
               $XML{'root'} = $1;
            }
            else {
               $error = 1;
            }
         }

         if ($XML{'web'} =~ /<files>(.*?)<\/files>/ms ) {
            $XML{'files'} = $1;

            if ($XML{'files'} =~ /<opensslBin>(.*?)<\/opensslBin>/ms ) {
               $XML{'opensslBin'} = $1;
            }
            else {
               $error = 1;
            }
         }

         if ($XML{'web'} =~ /<pkiris>(.*?)<\/pkiris>/ms ) {
            $XML{'pkiris'} = $1;
                  
            if ($XML{'pkiris'} =~ /<name>(.*?)<\/name>/ms ) {
               $XML{'pkiName'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<domain>(.*?)<\/domain>/ms ) {
               $XML{'domain'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<urnPrefix>(.*?)<\/urnPrefix>/ms ) {
               $XML{'urnPrefix'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<urnEntitlementPrefix>(.*?)<\/urnEntitlementPrefix>/ms ) {
               $XML{'urnEntitlementPrefix'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<maxRenewalsNum>(.*?)<\/maxRenewalsNum>/ms ) {
               $XML{'maxRenewalsNum'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<certSuffix>(.*?)<\/certSuffix>/ms ) {
               $XML{'certSuffix'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<homeURL>(.*?)<\/homeURL>/ms ) {
               $XML{'pkiHomeURL'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<homeURLs>(.*?)<\/homeURLs>/ms ) {
               $XML{'pkiHomeURLs'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<homeURLtxt>(.*?)<\/homeURLtxt>/ms ) {
               $XML{'pkiHomeURLtxt'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<authMethod>(.*?)<\/authMethod>/ms ) {
               $XML{'authMethod'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'pkiris'} =~ /<secret>(.*?)<\/secret>/ms ) {
               $XML{'secret'} = $1;
            }
            else {
               $error = 1;
            }
         }
         if ($XML{'web'} =~ /<organization>(.*?)<\/organization>/ms ) {
            $XML{'organization'} = $1;

            if ($XML{'organization'} =~ /<name>(.*?)<\/name>/ms ) {
               $XML{'orgName'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'organization'} =~ /<homeURL>(.*?)<\/homeURL>/ms ) {
               $XML{'orgHomeURL'} = $1;
            }
            else {
               $error = 1;
            }
            if ($XML{'organization'} =~ /<homeURLtxt>(.*?)<\/homeURLtxt>/ms ) {
               $XML{'orgHomeURLtxt'} = $1;
            }
            else {
               $error = 1;
            }
         }   
         else {
            $error = 1;
         }
      } 
      else {
        $error = 1;
      }
   }
   else {
      $error = 1;
   }
}
else {
   $error = 1;
}


if ( $error != 0 ) {
   print "\nError parseando el fichero XML de configuración.\n"
}
# Si no ha habido errores, creamos los directorios necesarios
else {
   print "OK\n";
   print "\nCreando los directorios de la aplicación ..... ";
   
   print "\n   Creando el directorio " . $XML{'rootWeb'};
   my $r1 = system ("/bin/mkdir -p " . $XML{'rootWeb'});

   print "\n   Creando el directorio " . $XML{'conf'};
   my $r2 = system ("/bin/mkdir -p " . $XML{'conf'});
   
   print "\n   Creando el directorio " . $XML{'data'};
   my $r3 = system ("/bin/mkdir -p " . $XML{'data'});
   
   print "\n   Creando el directorio " . $XML{'log'};
   my $r4 = system ("/bin/mkdir -p " . $XML{'log'});
   
   print "\n   Creando el directorio " . $XML{'ldapDir'};
   my $r5 = system ("/bin/mkdir -p " . $XML{'ldapDir'});
   
   print "\n... OK\n";
   print "\nCopiando los ficheros de la aplicación ... ";

   print "\n   Copiando ficheros a " . $XML{'rootWeb'};
   my $r6 = system ("cp -r var/www/html/* " . $XML{'rootWeb'});
   
   print "\n   Copiando ficheros a " . $XML{'conf'};
   my $r7 = system ("cp -r etc/pkIRIS/* " . $XML{'conf'});
   
   print "\n   Copiando ficheros a " . $XML{'data'};
   my $r8 = system ("cp -r var/pkIRIS/data/* " . $XML{'data'});
   
   print "\n   Copiando ficheros a " . $XML{'ldapDir'};
   my $r9 = system ("cp -r ldap/* " . $XML{'ldapDir'});

   print "\n... OK\n";
   # Tambien es neceario crear un enlace simbolico al directorio 
   # de los certificados ('...data/crt')
   print "\n   Creando enlace simbólico al directorio de los certificados ... ";
   my $r20 = system ("ln -s ".$XML{'data'}. "crt/ " . $XML{'rootWeb'} . "crt");

   print "\n... OK\n";
   print "\nCambiando los permisos de los ficheros ... ";

   print "\n   Cambiando los permisos a " . $XML{'rootWeb'};
   my $r10 = system ("chown -R ". $XML{'apacheUser'} . ":" . $XML{'apacheGroup'} . " " . $XML{'rootWeb'});
   my $r11 = system ("chmod -R 775 ". $XML{'rootWeb'});

   print "\n   Cambiando los permisos a " . $XML{'conf'};
   my $r12 = system ("chown -R ". $XML{'apacheUser'} . ":" . $XML{'apacheGroup'} . " " . $XML{'conf'});
   my $r13 = system ("chmod -R 775 ". $XML{'conf'});

   print "\n   Cambiando los permisos a " . $XML{'data'};
   my $r14 = system ("chown -R ". $XML{'apacheUser'} . ":" . $XML{'apacheGroup'} . " " . $XML{'data'});
   my $r15 = system ("chmod -R 775 ". $XML{'data'});

   print "\n   Cambiando los permisos a " . $XML{'log'};
   my $r16 = system ("chown -R ". $XML{'apacheUser'} . ":" . $XML{'apacheGroup'} . " " . $XML{'log'});
   my $r17 = system ("chmod -R 775 ". $XML{'log'});

   print "\n   Cambiando los permisos a " . $XML{'ldapDir'};   
   my $r18 = system ("chown -R ". $XML{'ldapUser'} . ":" . $XML{'ldapUser'} . " " . $XML{'ldapDir'});
   my $r19 = system ("chmod -R 775 ". $XML{'ldapDir'});

}

if ( $error != 0 ) {
   print "\nError creando los directorios de la aplicacion.\n"
}

else {
   print "\n... OK\n";
   print "\nCreando el fichero de configuración de la RA ..... ";

   ###########################################################################
   # Creamos el fichero de configuracion que usara la pkIRIS con los valores #
   # parseados del fichero XML.                                              #
   ###########################################################################

   # Abrimos el fichero
   open (CONF_FILE,">$XML{'conf'}pkIRIS.conf");
   # y vamos escribiendo en el linea a linea

   # Cabecera
   print CONF_FILE "<?php\n\n";
   print CONF_FILE "#################################################################\n";
   print CONF_FILE "#\n";
   print CONF_FILE "# pkIRIS-RA Configuration File\n";
   print CONF_FILE "#\n";
   print CONF_FILE "#################################################################\n\n";
   print CONF_FILE "# System\n";
   print CONF_FILE "\$version = \"v0.9.5b\";\n\n";

   # LDAP
   print CONF_FILE "# Ldap\n\n";
   print CONF_FILE "\$ldapVar['server']      = \"".$XML{'server'} . "\";\n";
   print CONF_FILE "\$ldapVar['port']        = \"".$XML{'port'} . "\";\n";
   print CONF_FILE "\$ldapVar['admin']       = \"".$XML{'admin'} . "\";\n";
   print CONF_FILE "\$ldapVar['pwd']         = \"".$XML{'pwd'} . "\";\n";
   print CONF_FILE "\$ldapVar['base']        = \"".$XML{'base'} . "\";\n";
   print CONF_FILE "\$ldapVar['baseCrt']     = \"".$XML{'baseCrt'} . "\";\n";
   print CONF_FILE "\$ldapVar['rdnAttr']     = \"".$XML{'rdnAttr'} . "\";\n";
   print CONF_FILE "\$ldapVar['adminCaMail'] = \"".$XML{'adminCaMail'} . "\";\n";
   print CONF_FILE "\$ldapVar['adminRaMail'] = \"".$XML{'adminRaMail'} . "\";\n\n";

   # Directories
   print CONF_FILE "# Directories\n\n";
   print CONF_FILE "\$dirVar['web']      = \"".$XML{'rootWeb'} . "\";\n";
   print CONF_FILE "\$dirVar['conf']     = \"".$XML{'conf'} . "\";\n";
   print CONF_FILE "\$dirVar['data']     = \"".$XML{'data'} . "\";\n";
   print CONF_FILE "\$dirVar['log']      = \"".$XML{'log'} . "\";\n";
   print CONF_FILE "\$dirVar['crl']      = \$dirVar['data'].\"crl/\";\n";
   print CONF_FILE "\$dirVar['csr']      = \$dirVar['data'].\"csr/\";\n";
   print CONF_FILE "\$dirVar['crt']      = \$dirVar['data'].\"crt/\";\n";
   print CONF_FILE "\$dirVar['crr']      = \$dirVar['data'].\"crr/\";\n";
   print CONF_FILE "\$dirVar['private']  = \$dirVar['data'].\"private/\";\n\n";

   print CONF_FILE "\$urlVar['root']     = \"".$XML{'root'} . "\";\n";
   print CONF_FILE "\$urlVar['cacert']   = \$urlVar['root'].\"cacert/\";\n";
   print CONF_FILE "\$urlVar['pkiAdmin'] = \$urlVar['root'].\"pkiAdmin/\";\n";
   print CONF_FILE "\$urlVar['pkiOper']  = \$urlVar['root'].\"pkiOper/\";\n";
   print CONF_FILE "\$urlVar['raAdmin']  = \$urlVar['root'].\$raUrl.\"/admin/\";\n";
   print CONF_FILE "\$urlVar['raPublic'] = \$urlVar['root'].\$raUrl.\"/\";\n";
   print CONF_FILE "\$urlVar['crt']      = \$urlVar['root'].\"crt/\";\n";
   print CONF_FILE "\$urlVar['crl']      = \$urlVar['root'].\"crl/\";\n";
   print CONF_FILE "\$urlVar['tools']    = \$urlVar['root'].\"tools/\";\n\n";

   # Files
   print CONF_FILE "# Files\n\n";
   print CONF_FILE "\$fileVar['RAsIndex'] = \$dirVar['conf'] . \"php/index.txt\";\n";
   print CONF_FILE "\$fileVar['log']      = \$dirVar['log'].\"pkIRIS.log\";\n\n";
   print CONF_FILE "\$bin['openssl']      = \"".$XML{'opensslBin'} . "\";\n\n";

   # Organization
   print CONF_FILE "# Organization\n\n";
   print CONF_FILE "\$organization['name']       = \"" . $XML{'orgName'} ."\";\n";
   print CONF_FILE "\$organization['homeURL']    = \"" . $XML{'orgHomeURL'} ."\";\n";
   print CONF_FILE "\$organization['homeURLtxt'] = \"" . $XML{'orgHomeURLtxt'} ."\";\n\n";

   # pkIRIS
   print CONF_FILE "# pkIRIS\n\n";
   print CONF_FILE "\$pkiris['name']                 = \"" . $XML{'pkiName'} ."\";\n";
   print CONF_FILE "\$pkiris['domain']               = \"" . $XML{'domain'} ."\";\n";
   print CONF_FILE "\$pkiris['urnPrefix']            = \"" . $XML{'urnPrefix'} ."\";\n";
   print CONF_FILE "\$pkiris['urnEntitlementPrefix'] = \"" . $XML{'urnEntitlementPrefix'} ."\";\n";
   print CONF_FILE "\$pkiris['maxRenewalsNum']       = \"" . $XML{'maxRenewalsNum'} ."\";\n";
   print CONF_FILE "\$pkiris['certSuffix']           = \"" . $XML{'certSuffix'} ."\";\n";
   print CONF_FILE "\$pkiris['homeURL']              = \"" . $XML{'pkiHomeURL'} ."\";\n";
   print CONF_FILE "\$pkiris['homeURLs']             = \"" . $XML{'pkiHomeURLs'} ."\";\n";
   print CONF_FILE "\$pkiris['homeURLtxt']           = \"" . $XML{'pkiHomeURLtxt'} ."\";\n";
   print CONF_FILE "\$pkiris['authMethod']           = \"plainSc\"; // Options: none, ldap, plainCc, plainSc, papi\n";
   print CONF_FILE "\$pkiris['secret']               = \"" . $XML{'secret'} ."\";\n\n";
   print CONF_FILE "?>\n";

   close CONF_FILE;
   system ("chown " . $XML{'apacheUser'} . ":" . $XML{'apacheGroup'} . " " . $XML{'conf'} . "pkIRIS.conf");
   
   print "OK\n";
}

print "
--------------------------------------------------------------------------------
pkIRIS-RA INSTALACIÓN TERMINADA !!!
--------------------------------------------------------------------------------\n";

print "Pulse INTRO para salir ";
$datos = <STDIN>;
