<?php

require '/pkiris/pkIRIS-RA/etc/pkIRIS/conf.cf';
include '/pkiris/pkIRIS-RA/var/www/html/core-ra.php';
include '/pkiris/pkIRIS-RA/var/www/html/errors.list';
#require '/pkiris/pkIRIS-CA/etc/pkIRIS/pkIRIS.conf';
#include '/pkiris/pkIRIS-CA/var/www/html/core-ca.php';
#include '/pkiris/pkIRIS-CA/var/www/html/errors.list';

###############################################################################
#                                                                             #
# Library File for pkIris                                                     #
#                                                                             #
###############################################################################

################################### FUNCTIONS #################################

#
# function checkAuth: 
#
function checkAuth($place) {
   global $ldapVar;
   global $pkiris;
   global $dirVar; 

   // Inicializamos la variable de error a cero
   $errorCode = "a0";
   session_start();
   if (!isset($_SESSION['user']) && $pkiris['authMethod']!= "none") {
      echo("<script type=\"text/javascript\">
      //<![CDATA[
      alert(\"No se ha autenticado, por favor introduzca su usuario y password.\");
      location.href='/';
      //]]>
      </script>");
   }
   else {

      // Obtenemos el pkirisCopaID a partir de pkirisSubjectID
      $user=$_SESSION['user'];
      switch ( $pkiris['authMethod'] ) {
         case "ldap":		 
            $idFromDN = getIdFromDN(getDn());
            if (!$idFromDN)
               $errorCode = "a1b1c15";
            else {
               if ($user == $idFromDN) {
                  $info = getPermFromDN(getDn());
                  if (!$info)
                     $errorCode = "a1b1c16";
                  else {
                     for( $i=0; $i < count($info[0]['irisuserentitlement']); $i++ ) {
                        list($k1,$k2,$k3,$k4,$k5,$attr,$value)=split(":",$info[0]['irisuserentitlement'][$i]);
                        if (($place == $attr)&&($value=="admin")) {
	                   $rights="true";   
                        }
                     }
                     if ($rights!="true") {
                        echo("<script type=\"text/javascript\">
                        //<![CDATA[
                        alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
		        location.href='/';
                        //]]>
                        </script>");
                     }
                  }
               }
               else {
                  session_start();
                  session_unset();
                  session_destroy();
        
                  echo("<script type=\"text/javascript\">
                  //<![CDATA[
                  alert(\"El certificado que ha elegido no pertenece a el usuario con el que ha hecho login.\");
                  location.href='/';
                  //]]>
                  </script>");
               }               
            }
	 break;
	 case "plainCc":
            $idFromDN = getIdFromDN(getDn());
            if (!$idFromDN)
               $errorCode = "a1b1c15";
            else {
               if ($user == $idFromDN) {
	          $permFile = fopen ($dirVar['conf'] . "perm", "r"); // Poner como variable global
                  $buf2 = fgets ($permFile);
                  $rights=0;
                  while ((!$rights)&&(!feof($permFile))) {
	             list ($userFile, $urnFile) = split (";", $buf2);
	             if ($user == $userFile) {
		        list($k1,$k2,$k3,$k4,$k5,$placeFile,$k7)=split(":",$urnFile);
                        // Le quitamos los espacios en blanco que pudiera haber
                        $placeFile = trim($placeFile);
		        if ($place == $placeFile) {
	                   $rights=1;
		        }
		     }
	             $buf2 = fgets($permFile);
                  }  
                  fclose ($permFile);
                  if (!$rights) {
	             echo("<script type=\"text/javascript\">
                     //<![CDATA[
	             alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
	             location.href='/';
                     //]]>
                     </script>");
                  }
	       }   
               else {
	          session_start();
                  session_unset();
                  session_destroy();
	
                  echo("<script type=\"text/javascript\">
                  //<![CDATA[
                  alert(\"El certificado que ha elegido no pertenece a el usuario con el que ha hecho login.\");
                  location.href='/';
                  //]]>
                  </script>");
               }
            }
         break;
	 case "plainSc":
	    $permFile = fopen ($dirVar['conf'] . "perm", "r"); // Poner como variable global
	    $buf2 = fgets ($permFile);
	    $rights=0;

	    while ((!$rights)&&(!feof($permFile))) {
	      list ($userFile, $urnFile) = split (";", $buf2);
	      if ($user == $userFile) {
		list($k1,$k2,$k3,$k4,$k5,$placeFile,$k7)=split(":",$urnFile);
                // Le quitamos los espacios en blanco que pudiera haber
                $placeFile = trim($placeFile);
		if ($place == $placeFile) {
		   $rights=1;   
		}
	      }
	      $buf2 = fgets($permFile);
	    }
	    fclose ($permFile);
	    if (!$rights) {
	       echo("<script type=\"text/javascript\">
	       //<![CDATA[
	       alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
	       location.href='/';
	       //]]>
	       </script>");
	    }
         break;
      }   
   }

// Hacemos una llamada a la funcion encargada de manejar los posibles errores
// producidos en cualquier parte del codigo. Si la variable $errorCode ha sido 
// inicializada a un valor distinto de 'a0',capturamos el error y lo mostramos 
// por pantalla
$pkiLog['status'] = "none";
$pkiLog['eee'] = "none";
$pkiLog['user'] = "none";
$pkiLog['error'] = $errorCode;
pkirisErrorHandler($pkiLog);

}

#
# function ldap_get_info: Obtiene solo la informacion indicada por $justthese 
# de la entrada ldap correspondiente a $ldapVar['base']Dn, con el filtro $filter
#
function ldap_get_info($baseDn, $filter, $justthese) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;	
   $ds=ldap_connect($ldapVar['server'], $ldapVar['port']);

   if (!$ds) 
      $errorCode = "a1b1c1";
   else {
      // bind with appropriate dn to give update access
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r) 
         $errorCode = "a1b1c2";
      else {
         $rs=ldap_search($ds, $baseDn, $filter, $justthese);
         if (!$rs)
            $errorCode = "a1b1c3";
         else {
            $info=ldap_get_entries($ds, $rs);
            if ( !$info ) 
               $errorCode = "a1b1c4";
            else 
               $retValue = $info;
         }
      }
      ldap_close($ds);
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog); 

   return $retValue;
}

#
# function ldap_get_cert: Obtiene el certificado indicado por $ldapVar['base']Dn
#
function ldap_get_cert($baseDn, $filter) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   $ds=ldap_connect($ldapVar['server'], $ldapVar['port']);

   if (!$ds) 
      $errorCode = "a1b1c1";
   else{
      // bind with appropriate dn to give update access
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r) 
         $errorCode = "a1b1c2";
      else {
         $justthese = array("usercertificate");      
         $rs=ldap_search($ds, $baseDn, $filter, $justthese);
         if (!$rs)
            $errorCode = "a1b1c3";
         else {   
            $entry = ldap_first_entry($ds, $rs);
            if (!$entry) 
               $errorCode = "a1b1c5";
            else{
               // Esto se hace porque como el certificado esta en binario en el ldap 
               // tenemos que traerlo con esta funcion si no no lo lee bien
               $cert = ldap_get_values_len($ds, $entry, "userCertificate;binary");
               if (!$cert)
                  $errorCode = "a1b1c6";
               else
                  $retValue = $cert;               
            }
         }
         ldap_close($ds);
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
   
   return $retValue;
}

#
# function ldap_mod_info: Modifica una entrada existente indicada por $dn
# con la informacion contenida en $info
#
function ldap_mod_info($dn, $info) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   $ds=ldap_connect($ldapVar['server'], $ldapVar['port']);   
   if (!$ds) 
      $errorCode = "a1b1c1";
   else{
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r) 
         $errorCode = "a1b1c2";
      else {
         $retValue = ldap_modify($ds, $dn, $info);
	 if ( !$retValue ) 
            $errorCode = "a1b1c7";
      }
      ldap_close($ds);	
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
   
   return $retValue;
}

#
# function ldap_mod_add_info: Anyade informacion a una solicitud ya existente
#
function ldap_mod_add_info($dn, $info) {
   global $ldapVar;

   $errorCode = "a0";	
   $retValue = false;
   $ds = ldap_connect($ldapVar['server'], $ldapVar['port']);
   if (!$ds) 
      $errorCode = "a1b1c1";
   else {      
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r) 
         $errorCode = "a1b1c2";
      else {
         $retValue = ldap_mod_add($ds, $dn, $info);
	 if ( !$retValue )
            $errorCode = "a1b1c8";
      }
      ldap_close($ds);
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function ldap_add_info: Anyade informacion a una nueva solicitud
#
function ldap_add_info($dn, $info) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   $ds = ldap_connect($ldapVar['server'], $ldapVar['port']);
   if (!$ds)
      $errorCode = "a1b1c1";
   else {
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r)
         $errorCode = "a1b1c2";
      else {
         $retValue = ldap_add($ds, $dn, $info);
         if ( !$retValue )
            $errorCode = "a1b1c9";
      }
      ldap_close($ds);
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function ldap_del_record: borra una entrada indicada mediante el dn del servicio de directorio
#

function ldap_del_record($dn) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   $ds = ldap_connect($ldapVar['server'], $ldapVar['port']);
   if (!$ds)
      $errorCode = "a1b1c1";
   else {
      $r=ldap_bind($ds, $ldapVar['admin'], $ldapVar['pwd']);
      if(!$r)
         $errorCode = "a1b1c2";
      else {
         $retValue = ldap_delete($ds, $dn);
         if ( !$retValue )
            $errorCode = "a1b1c10";
      }
      ldap_close($ds);
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function getStatus: Devuelve el estado de la solicitud indicada por su 
# numero copa.
#
function getStatus($copa) {
   global $ldapVar;
   
   $errorCode = "a0";
   $retValue = false;
   // Obtenemos el estado de la solicitud
   $filter = "(&(objectclass=pkirisCertificate)(".$ldapVar['rdnAttr']."=$copa))";
   $justthese = array ("pkirisstatus");
   $rs = ldap_get_info($ldapVar['base'], $filter, $justthese);
   if ( !$rs )
      $errorCode = "a1b1c11";
   else{
      if ( $rs['count'] > 0 ) 
         $retValue = $rs[0]["pkirisstatus"][0];
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function changeStatus: Esta funcion cambia el estado de la solicitud indicada
# por $copa
#
function changeStatus($copa, $status) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   // Comprobamos si $status contiene un valor valido	
   if ($status=="new" OR $status=="renew" OR $status=="issued" OR $status=="approved" OR $status=="ra2ca" OR $status=="csr-refused" OR $status=="rnr-refused" OR $status=="crr-refused" OR $status=="csr-denied" OR $status=="rnr-denied" OR $status=="revoke" OR $status=="revoked-ca" OR $status=="revoked-ra" OR $status=="revoked-usr" OR $status=="ca2ra" OR $status=="csr-pending" OR $status=="rnr-pending" OR $status=="crr-pending" OR $status=="csr-deferred" OR $status=="rnr-deferred" OR $status=="crr-deferred" OR $status=="error" ) {	   
      $newStatus["pkirisstatus"] = "$status";
      $dn = $ldapVar['rdnAttr']."=$copa," . $ldapVar['base'];
      $retValue = ldap_mod_info($dn, $newStatus);      
      if ( !$retValue )
         $errorCode = "a1b1c12";
    }
   else
      $errorCode = "a1b1c20";       

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
   
   return $retValue;
}

#
# function writeLog: writes in a log file the action ($action) done  
# for the user ($user). Also writes date, copa number and error code
#
function writeLog ($pkiLog) {
   global $fileVar;

   $errorCode = "a0";
   $retValue = false;
   

   if ( $pkiLog['status'] != null )
      $action = $pkiLog['status'];
   else 
      $action = "none";

   if ( $pkiLog['eee'] != null )
      $copa = $pkiLog['eee'];
   else
      $copa = "none";

   if ( $pkiLog['user'] != null )
      $user = $pkiLog['user'];
   else
      $user = "none";

   if ( $pkiLog['error'] != null )
      $error = $pkiLog['error'];
   else
      $error = "a0";

   // Abrimos el fichero de log para anyadirle una nueva linea
   $fd = fopen ($fileVar['log'], "a");
   if (!$fd)
      $errorCode = "a1b1c17"; 
   else {
      $action = sprintf("%-15s", $action);	  
      $copa = sprintf ("%-9s", $copa);

      if ($error == "a0")
         $retValue = fwrite ($fd, "\n" . date("Ymd H:i:s") . " [" . $action. "] eee=" . $copa. " usr=" . $user);      
      else
         $retValue = fwrite ($fd, "\n" . date("Ymd H:i:s") . " [" . $action. "] eee=" . $copa. " usr=" . $user. " err=" . $error);

      if (!$retValue)
         $errorCode = "a1b1c18";
   } 
   $r = fclose ($fd);
   if (!$r)
      $errorCode = "a1b1c19";

   //pkirisErrorHandler($errorCode);
   return $retValue;
}

#
# function getDn: return the distinguish name of the certificate that you have
# used to validate to the aplication. In other case return false.
#
function getDn () {
   $retValue = false;
   
   if ( isset($_SERVER["SSL_CLIENT_S_DN"]) ) {
      $arrayDn=split("/",$_SERVER["SSL_CLIENT_S_DN"]);
      for ($i = 1; $i < count($arrayDn); $i++ ) {
         if ($i == 1)  		 
	    $retValue = strtolower($arrayDn[$i]);
	 else
            $retValue = $retValue .",". strtolower($arrayDn[$i]);
      }
   }
   return $retValue;
}

#
# function getPassFromDN: return an array with three fields. First with the 
# distinguish name, the second with the common name and the last one with the 
# surname. This function was created for the authentication process.
#
function getPermFromDN($dn) { 
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(|(pkirisStatus=issued)(pkirisStatus=revoke)(pkirisStatus=ra2ca)))";
   $justthese = array($ldapVar['rdnAttr']);
   $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
   if (!$result)
      $errorCode = "a1b1c11";
   else {
      if ( $result['count'] > 0 ) {
         $id = $result[0][$ldapVar['rdnAttr']][0];
         list($ab,$c)=split("c",$id);

         // With the value of pkirisID we make another search for the username, 
         // lastname and password.
         $filter = "(&(objectclass=pkirisEndEntity)(".$ldapVar['rdnAttr']."=$ab))";
         $justthese = array("dn","cn","sn","irisuserentitlement");
         $retValue = ldap_get_info($ldapVar['base'],$filter,$justthese);
         if (!$retValue)
            $errorCode = "a1b1c11";
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
 
   return $retValue;
}

#
# function getUserCopaFromDN: return the user copa number from SubjectDN. 
# This function was created for the revocation process.
#
function getUserCopaFromDN($dn) {
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(pkirisStatus=issued))";
   $justthese = array($ldapVar['rdnAttr']);
   $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
   if ( !$result ) 
      $errorCode = "a1b1c11";
   else {
      if ( $result['count'] > 0 ) {
         $id = $result[0][$ldapVar['rdnAttr']][0];
         list($retValue,$c)=split("c",$id);
      }
   }   
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function getIdFromDN: return the user ID from SubjectDN.
#
function getIdFromDN($dn) {
   global $ldapVar;
  
   $errorCode = "a0"; 
   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(|(pkirisStatus=issued)(pkirisStatus=revoke)(pkirisStatus=ra2ca)))";
   $justthese = array("pkirisID");
   $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
   if ( !$result )
      $errorCode = "a1b1c11";
   else {
      if ( $result['count'] > 0 ) {
         $retValue = $result[0]["pkirisid"][0];
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}
						     
#
# function getTrace: create and return a valid pkirisTrace. 
#
function getTrace ($traceVals) { 
   global $pkiris;
   global $raPrivKey;

   $errorCode = "a0";
   $retValue = false; 
   // Si no esta definida la variable global que contiene la clave
   // privada de la RA '$raPrivKey', necesitamos obtenerla del fichero
   // de claves (este caso solo debe cumplirse en la CA) o del propio
   // fichero de configuracion de la RA (para algunas operaciones en la RA)
   if ( !isset($raPrivKey) ) {
      // Nos quedamos con el numero de ra ('ai') del copa
      list ($raCopa, $k) = split ("b", $traceVals["copa"]);
      $raPrivKey = getRaPrivKey($raCopa);
      if ( !$raPrivKey ) 
         $errorCode = "a1b1c21";
   }

   // Si no se ha producido ningun error al obtener la clave de la RA,
   // construimos la traza
   if ( $errorCode == "a0") {
      $status = $traceVals["status"];
      // Le anyadimos el prefijo, la fecha y el estado a la traza
      $pkirisTrace = $pkiris['urnPrefix'] . ":csr:state:".$traceVals["currentDate"].":$status";

      $comments = $traceVals["comments"];
      // Si hay comentarios, le tenemos que anyadir el punto y coma y 'comment='
      // al principio. Ademas, si hubiese algun ';' en el comentario, lo 
      // sustituimos por su codigo ascii (%59) para evitar comflictos
      if ($comments != '')
         $comments = ";comment=". str_replace(";","%59", $comments);
    
      // Dependiendo del estado, le anyadiremos unos valores u otros a la traza

      // En caso de error le anyadimos su codigo y los comentarios
      if ($status == "error")
         $pkirisTrace = $pkirisTrace . ";level=".$traceVals["level"].";invalidityDate=".$traceVals["invalidityDate"]."$comments";
      
      // Le anyadimos el motivo de revocacion, la fecha de invalidez y comentarios
      else if ( $status == "revoke" || $status == "crr-pending" || strstr($status,"revoked-") )
         $pkirisTrace = $pkirisTrace . ";reason=".$traceVals["revocationReason"].";invalidityDate=".$traceVals["invalidityDate"]."$comments";

      // En este caso solo le anyadiremos los comentarios (en caso de existir)      
      else if ( $status == "approved" || strstr($status,"-denied") || strstr($status,"-refused") || strstr($status,"-deferred") )
         $pkirisTrace = $pkirisTrace . $comments;
   
      // Le anyadimos la firma al final de la traza
      $retValue = $pkirisTrace . ":" . sha1($pkirisTrace.$raPrivKey.$traceVals["copa"]);
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;   
}

#
# function getTracesFromStatus: devuelve un array con las trazas anyadidas
# al ldap desde la que tiene estado $status (inclusive) hasta la ultima, 
# ordenadas por fecha.
#
function getTracesFromStatus ($copa, $status) {
   global $ldapVar;
   global $pkiris;
   global $traceIndices;

   $errorCode = "a0";
   $retValue = false;   
   $filter = ($ldapVar['rdnAttr']."=$copa");
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud con numero copa indicado por $copa
   $result = ldap_get_info($dn,$filter,$justthese);

   if ( !$result )
      $errorData = "a1b1c11";
   else {
      $pkirisTraces = $result[0]["pkiristrace"];
      if ( $pkirisTraces['count'] > 0 ) {
         // Ordenamos el array de trazas. Debido a su estructura, se ordena por fecha
         sort($pkirisTraces);

         $lastStatusFound = -1;
         // En el siguiente array sera el que devolveremos
         $arrayTraces = array();

         while (list($index, $value) = each($pkirisTraces)) {
            // Parseamos la traza por el prefijo $pkiris['urnPrefix']
            list($k, $tmp) = split($pkiris['urnPrefix'], $value);
            // y metemos en un array el resto de componentes de la traza
            $tr = split(":", $tmp);
            // Le quitamos el primer elemento porque no contiene nada
            array_shift ($tr);			
      
            // En traceIndices['status'] se encuentra el indice correspondiente al
            // campo que contiene el estado de la traza (0, 1 ... n)
            $tmpStatus = $tr[$traceIndices['status']];
            list($traceStatus, $k) = split (";", $tmpStatus);
     
            // Si es igual al estado que estamos buscando, nos quedamos con el
            // indice del array
            if ( $traceStatus == $status ) 
               $lastStatusFound = $index;	 
         }

         if ($lastStatusFound != -1) {
            // Recorremos el array $pkirisTraces desde el elemento indicado por
            // $lastStatusFound y guardamos las trazas en el array $arrayTraces
            for ($i = $lastStatusFound ; $i < count ($pkirisTraces) - 1 ; $i++)
               array_push($arrayTraces, $pkirisTraces[$i]);
            $retValue = $arrayTraces;
         }
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
   
   return $retValue;
}

#
# function getRequestTypeFromTraces: Obtiene el tipo de la solicitud $copa
# que estemos tratando (csr o rnr). Comprueba si la primera traza es new (csr) 
# o renew (rnr). 
#
function getRequestTypeFromTraces($copa) {
   global $ldapVar;
   global $pkiris;
   global $traceIndices;
  
   $retValue = false;
   $errorCode = "a0"; 
   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud indicada por $copa,
   $pkirisTraces = ldap_get_info($ldapVar['base'],$filter,$justthese);
   if ( !$pkirisTraces )
      $errorCode = "a1b1c11";
   else {
      if ( $pkirisTraces['count'] > 0 ) {
         // las ordenamos
         sort($pkirisTraces);
         // y nos quedamos con el estado de la primera traza. Al estar ordenadas por 
         // fecha, la primera traza tiene que tener estado 'new' o 'renew' (si no ha
         // habido ningun error en algun proceso).
         $firstTrace = $pkirisTraces[1]['pkiristrace'][0]; // primera traza del array
         // Parseamos la traza por el prefijo $pkiris['urnPrefix']
         list($k, $tmp) = split($pkiris['urnPrefix'], $firstTrace);
         // y metemos en un array el resto de componentes de la traza
         $tr = split(":", $tmp);
         // Le quitamos el primer elemento porque no contiene nada
         array_shift ($tr);
   
         // Obtenemos el estado
         $tmpStatus = $tr[$traceIndices['status']];
         list($traceStatus, $k) = split (";", $tmpStatus);
         if ($traceStatus == "new")
            $retValue = "csr";
         else if ($traceStatus == "renew")
            $retValue = "rnr";
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;  
}

#
# function setExportedStatus: recibe un array con el codigo copa de todas las
# solicitudes pendientes de ser exportadas y les cambia el estado a 'ra2ca' o
# 'ca2ra', dependiendo del origen y el destino de la solicitud. Ademas, se le
# cambia la fecha y se genera e inserta el el ldap una traza con el nuevo 
# estado.
#
function setExportedStatus ( $copasArray , $status) {
   global $ldapVar;
   
   $errorCode = "a0";
   $retValue = false;
   $currentDate = date("YmdHis");   
    
   while ( list(,$copa) = each($copasArray) ) {
      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
	 $errorCode = "a1b1c23";
      else {
         // Esta comprobacion se hace para evitar que se escriba dos veces la
         // misma traza al recargar el navegador
         if ($lastStatus != $status) {
            // Traza con el nuevo estado
	    $traceVals["status"] = $status;
	    $traceVals["copa"] = $copa;
	    $traceVals["currentDate"] = $currentDate;
	  
	    // Construimos la traza con los valores de $traceVals
	    $newTrace = getTrace($traceVals);

	    $dn = $ldapVar['rdnAttr']."=".$copa.",".$ldapVar['base'];
	    $updateFields["pkirisstatus"] = $status;
	    $updateFields["pkirisdate"] = $currentDate;
	    $urn["pkiristrace"] = $newTrace;

	    // Modificamos el campo pkiDate y pkiStatus del ldap
	    $r = ldap_mod_info ($dn, $updateFields);
	    if (!$r)
	       $errorCode = "a1b1c11";
	    else {
	       // Modificamos el campo pkiTrace para agregar la nueva traza firmada
	       $r = ldap_mod_add_info ($dn, $urn);
               if (!$r) 
                  $errorCode = "a1b1c13";
            }
         }
         else
            $errorCode = "a1b1c22";
      }
   }//while

   if ( $errorCode == "a0" )
      $retValue = true;
  
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
    
   return $retValue;   
}

#
# function pkirisErrorHandler($copa): recibe el codigo copa con el 
# identificador del error producido y lo muestra en pantalla. El mensaje
# mostrado lo obtenemos del array '$errorList' 
#
function pkirisErrorHandler($pkiLog) {
   global $errorList;
   
   $errorCode = $pkiLog['error'];

   if ( $errorCode != "a0" ) {
      echo "Error $errorCode: " . $errorList[$errorCode];
      writeLog ($pkiLog);
   }
}


############################### VARIABLES #####################################

// Revocation Reasons Array
$revReasons[0] = "unspecified";
$revReasons[1] = "keyCompromise";
$revReasons[2] = "cACompromise";
$revReasons[3] = "affiliationChanged";
$revReasons[4] = "superseded";
$revReasons[5] = "cessationOfOperation";
$revReasons[6] = "certificateHold";
$revReasons[7] = "removeFromCRL";
$revReasons[8] = "privilegeWithdrawn";
$revReasons[9] = "aACompromise";

// Trace elements positions 
$traceIndices['csr'] = '0';
$traceIndices['state'] = '1';
$traceIndices['date'] = '2';
$traceIndices['status'] = '3';
$traceIndices['sha1'] = '4';

###############################################################################

?>
